<?php
	class Dashboard{

		public static function Utama()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;

			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			// $temp[] = array('name'=>'JAMKESDA KOTA','y'=>25);
			// $temp[] = array('name'=>'Data 2','y'=>15);
			// $temp[] = array('name'=>'Data 3','y'=>35);
			// $temp[] = array('name'=>'Data 4','y'=>15);
			// $temp[] = array('name'=>'Data 5','y'=>15);
			// $arrReturn['sourceDataProp'] = $temp;


			$objDb = QApplication::$Database[1];
			$strSql = "
				SELECT 
				  contract_service_name AS cara_bayar, 
				  COUNT(id) AS jumlah 
				FROM hmis_patient_nursing 
				WHERE state = 'A'
				GROUP BY contract_service_name
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				$temp = array();
				while ($row = $objDbResult->FetchArray()) {
					$temp[] = array('name'=>$row['cara_bayar'] ,'y'=> intval($row['jumlah']));
				}
				$arrReturn['sourceDataProp'] = $temp;
			}


			$temp = array();
			$arrReturn['sourceTitleGraphMonthly'] = 'Kunjungan Tahun ' . $strYear;
			/*
			$temp = array();
			$arrReturn['sourceTitleGraphMonthly'] = 'Kunjungan Tahun ' . $strYear;
			$temp[] = array('name'=>'Data 1','y'=>25);
			$temp[] = array('name'=>'Data 2','y'=>15);
			$temp[] = array('name'=>'Data 3','y'=>35);
			$temp[] = array('name'=>'Data 4','y'=>15);
			$temp[] = array('name'=>'Data 5','y'=>15);
			$temp[] = array('name'=>'Data 6','y'=>15);
			$temp[] = array('name'=>'Data 7','y'=>15);
			$temp[] = array('name'=>'Data 8','y'=>25);
			$temp[] = array('name'=>'Data 9','y'=>15);
			$temp[] = array('name'=>'Data 10','y'=>20);
			$temp[] = array('name'=>'Data 11','y'=>30);
			$temp[] = array('name'=>'Data 12','y'=>40);
			$arrReturn['sourceDataGraphMonthly'] = $temp;
			*/

			$data = array();
			$arrReturn['sourceTitleGraphMonthly'] = 'Kunjungan Tahun ' . $strYear;
			for ($c=1;$c<=12;$c++){
				//$temp[] = array('name'=>'Data '.$c,'y'=>0);
				$data[$c] = 0;
			}
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
					//$temp[] = array('name' => 'Data ' . $row[by_month], 'y' => $row[jumlah]);
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataGraphMonthly'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}

		public static function Kunjungan()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strMonth = $objPost->month;

			$arrReturn = array();
			$arrReturn['titleBarThisMonth'] = 'Kunjungan '.date('F, Y',mktime(0,0,0,$strMonth,1,$strYear));
			$arrReturn['titleBarThisYear'] = 'Kunjungan '.date('Y',mktime(0,0,0,$strMonth,1,$strYear));


			$data = array();
			$arrReturn['sourceTitleGraphMonthly'] = 'Kunjungan Tahun ' . $strYear;
			for ($c=1;$c<=12;$c++){
				//$temp[] = array('name'=>'Data '.$c,'y'=>0);
				$data[$c] = 0;
			}
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row['by_month']]=(int)$row['jumlah'];
					//$temp[] = array('name' => 'Data ' . $row[by_month], 'y' => $row[jumlah]);
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataGraphMonthly'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}


		public static function KunjunganHarian()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strMonth = $objPost->month;
			$strKategori = $objPost->kategori;

			$arrReturn = array();
			$arrReturn['titleBarThisMonth'] = 'Kunjungan '.date('F, Y',mktime(0,0,0,$strMonth,1,$strYear));
			$arrReturn['titleBarThisYear'] = 'Kunjungan '.date('Y',mktime(0,0,0,$strMonth,1,$strYear));
			$dtAwalBulan = new QDateTime($strYear . '-' . $strMonth . '-' . '1');
			$dtAwalBulan->AddMonths(1);
			$dtAwalBulan->AddDays(-1);

			$tglTerakhir = $dtAwalBulan->PhpDate('d');

			$data = array();
			if($strKategori == 1){
				$strTitle = 'Kunjungan Rawat Jalan';
			}elseif($strKategori == 2){
				$strTitle = 'Kunjungan IGD';
			}elseif($strKategori == 3){
				$strTitle = 'Pasien MRS';
			}

			$poli = $objPost->poli;
			if($poli){
				$strTitle .= ' ' . $poli;
			}
			$bulan =[
				'',
				'Januari',
				'Februari',
				'Maret',
				'April',
				'Mei',
				'Juni',
				'Juli',
				'Agustus',
				'September',
				'Oktober',
				'November',
				'Desember'
			];
			$arrReturn['sourceTitleGraphMonthly'] = $strTitle. ' Bulan ' . $bulan[$strMonth] . ' Tahun ' . $strYear;
			for ($c=1;$c<=$tglTerakhir;$c++){
				//$temp[] = array('name'=>'Data '.$c,'y'=>0);
				$data[$c] = 0;
			}
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('day', nursing_start_date) AS by_day, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE 
				date_part('month', nursing_start_date) = '$strMonth' AND  date_part('year', nursing_start_date) = '$strYear'
				AND on_partition BETWEEN '$strYear-$strMonth-01' AND '$strYear-$strMonth-$tglTerakhir'
			   AND nursing_category = '". $strKategori . "'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_day
			";
			if($poli){
				$strSql = "
			   	SELECT date_part('day', nursing_start_date) AS by_day, COUNT(hmis_patient_nursing.id) AS jumlah
			   	FROM hmis_patient_nursing
			   	WHERE 
				date_part('month', nursing_start_date) = '$strMonth' AND  date_part('year', nursing_start_date) = '$strYear'
				AND on_partition BETWEEN '$strYear-$strMonth-01' AND '$strYear-$strMonth-$tglTerakhir'
			   	AND department_name = '". $poli . "'
			   	AND department_name != 'APOTIK RAWAT INAP'
				AND department_name != 'DEPO OK'
				AND department_name != 'APOTIK RAWAT DARURAT'
				AND department_name != 'INSTALASI HEMODIALISA'
				AND department_name != 'LABORATORIUM'
				AND department_name != 'RADIOLOGI'
				AND state = 'A'
				GROUP BY by_day
				";
			}
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row['by_day']]=(int)$row['jumlah'];
					//$temp[] = array('name' => 'Data ' . $row[by_month], 'y' => $row[jumlah]);
				}
			}
			$temp = array();
			for ($c=1;$c<=$tglTerakhir;$c++){
				$temp[] = array('name'=>'Tgl '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataGraphMonthly'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		} //testing

		public static function ProposiKunjunganCaraBayar(){
			$objPost = System::genObject('post');

			list($minDate,$maxDate) = @explode(' - ',$objPost->range);
			list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
			list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);

			$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
			$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');
			$strKategori = $objPost->kategori;

			if($strKategori == 1){
				$heading = 'Kunjungan Rawat Jalan Berdasarkan Cara Bayar';
			}elseif($strKategori == 2){
				$heading = 'Kunjungan IGD Berdasarkan Cara Bayar';
			}elseif($strKategori == 3){
				$heading = 'Perawatan Inap Berdasarkan Cara Bayar';
			}

			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			
			$objDb = QApplication::$Database[1];
			$strSql = "
				SELECT 
				  contract_service_name AS cara_bayar, 
				  COUNT(id) AS jumlah 
				FROM hmis_patient_nursing 
				WHERE state = 'A'
				AND nursing_category = '$strKategori'
				AND nursing_start_date >= '$objMinDate'
				AND nursing_start_date <= '$objMaxDate'
				AND department_name != 'APOTIK RAWAT INAP'
				AND department_name != 'DEPO OK'
				AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
				GROUP BY contract_service_name
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				$temp = array();
				while ($row = $objDbResult->FetchArray()) {
					$temp[] = array('name'=>$row['cara_bayar'].'<br>'.$row['jumlah'] ,'y'=> intval($row['jumlah']));
				}
				$arrReturn['sourceDataProp'] = $temp;
			}


			$temp = array();
			$arrReturn['sourceTitleGraphMonthly'] = $heading .' ('.$objPost->range.')';
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);
		}

		public static function ProposiKunjunganCaraBayarPoliRuangan(){
			$objPost = System::genObject('post');

			list($minDate,$maxDate) = @explode(' - ',$objPost->range);
			list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
			list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);

			$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
			$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');
			$strPoliRuangan = $objPost->poliruangan;

			// if($strKategori == 1){
			// 	$heading = 'Kunjungan Rawat Jalan';
			// }elseif($strKategori == 2){
			// 	$heading = 'Kunjungan IGD';
			// }elseif($strKategori == 3){
			// 	$heading = 'Perawatan Inap';
			// }
			$heading = 'Kunjungan Berdasarkan Cara Bayar ' . $strPoliRuangan;
			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar P';
			
			$objDb = QApplication::$Database[1];
			$strSql = "
				SELECT 
				  contract_service_name AS cara_bayar, 
				  COUNT(id) AS jumlah 
				FROM hmis_patient_nursing 
				WHERE state = 'A'
				AND nursing_start_date >= '$objMinDate'
				AND nursing_start_date <= '$objMaxDate'
				AND department_name = '$strPoliRuangan'
				GROUP BY contract_service_name
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				$temp = array();
				while ($row = $objDbResult->FetchArray()) {
					$temp[] = array('name'=>$row['cara_bayar'].'<br>'.$row['jumlah'] ,'y'=> intval($row['jumlah']));
				}
				$arrReturn['sourceDataProp'] = $temp;
			}


			$temp = array();
			$arrReturn['sourceTitleGraphMonthly'] = $heading .' ('.$objPost->range.')';
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);
		}

		public static function JumlahKunjungan()
		{
			$objPost = System::genObject('post');
						
			list($minDate,$maxDate) = @explode(' - ',$objPost->range);
			list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
			list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);

			$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
			$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');

			$strKategori = $objPost->kategori;

			$data = array();
			if($strKategori == 1){
				$heading = 'Kunjungan Rawat Jalan';
			}elseif($strKategori == 2){
				$heading = 'Kunjungan IGD';
			}elseif($strKategori == 3){
				$heading = 'Pasien MRS';
			}
			$arrReturn['sourceTitleGraphMonthly'] = $strTitle. ' ' . $objPost->range;
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			SELECT 
			department_name AS poli_ruangan, 
			COUNT(id) AS jumlah 
			FROM hmis_patient_nursing 
			WHERE state = 'A'
			AND nursing_category = '$strKategori'
			AND nursing_start_date >= '$objMinDate'
			AND nursing_start_date <= '$objMaxDate'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			GROUP BY department_name
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				$temp = array();
				$arrKategori = array();
				while ($row = $objDbResult->FetchArray()) {
					$temp[] = array('name'=>$row['poli_ruangan'],'y'=> intval($row['jumlah']));
					$arrKategori[] =  $row['poli_ruangan'];
				}
				$arrReturn['sourceDataProp'] = $temp;
				$arrReturn['kategori'] = $arrKategori;
			}

			if($strKategori == 1){
				$strTitle = 'Kunjungan Rawat Jalan';
			}elseif($strKategori == 2){
				$strTitle = 'Kunjungan IGD';
			}elseif($strKategori == 3){
				$strTitle = 'Perawatan Inap';
			}

			$temp = array();
			$arrReturn['sourceTitleGraphMonthly'] = $heading .' ('.$objPost->range.')';
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}
		public static function DalamTahun()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strKategori = $objPost->kategori;

			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			
			if($strKategori == 1){
				$strTitle = 'Kunjungan Rawat Jalan';
			}elseif($strKategori == 2){
				$strTitle = 'Kunjungan IGD';
			}elseif($strKategori == 3){
				$strTitle = 'Perawatan Inap';
			}elseif($strKategori == 3){
				$strTitle = 'BBL';				
			}else{
				$strKategori = 0;
			}
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '1'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRajal'] = $temp;

			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '2'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataIGD'] = $temp;

			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '3'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRanap'] = $temp;


			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '3'
			   			   AND referal_in_from_name = '73'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRanap1'] = $temp;
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '3'
			   			   AND referal_in_from_name <> '73'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRanap'] = $temp;


			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}
		public static function PasienKRS()
		{

			$objPost = System::genObject('post');
						
			list($minDate,$maxDate) = @explode(' - ',$objPost->range);
			list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
			list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);

			$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
			$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');

			// $arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			$jum_sembuh = $jum_aps = $jum_dirujuk = $jum_k48j = $jum_l48j = 0;

			$objDb = QApplication::$Database[1];
			$strSql = "
			SELECT referal_out_reason, nursing_end_date, nursing_start_date
		  	FROM hmis_patient_nursing 
		  	WHERE state = 'A'
		  	AND nursing_category = '3'
		  	AND nursing_start_date >= '$objMinDate'
		  	AND nursing_start_date <= '$objMaxDate'
			AND register_json LIKE '%StatusIndex%'
			AND document_back_back_date IS NOT NULL
			AND checklist_status_kelengkapan = 'LENGKAP'
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					// $row['referal_out_reason'];
					// $row['nursing_end_date'];
					// $row['nursing_start_date'];
					$caraPulang = $row['referal_out_reason'];
							if($caraPulang == 'Sembuh'){
								$jum_sembuh++;
							}
							if($caraPulang == 'Pulang Paksa'){
								$jum_aps++;
							}
							if($caraPulang == 'Dirujuk'){
								$jum_dirujuk++;
							}
							if($caraPulang == 'Meninggal'){
								$date1=date_create($row['nursing_start_date']);
								$date2=date_create($row['nursing_end_date']);
								$diff=date_diff($date1,$date2);
								$durasi = $diff->d;
								if($durasi < 2)
								{
									$jum_k48j++;
								}
								else{
									$jum_l48j++;
								}

							}
				}
			}
			$temp = array();
			$temp[] = array('name'=>'sembuh','y'=>$jum_sembuh);
			$temp[] = array('name'=>'aps','y'=>$jum_aps);
			$temp[] = array('name'=>'dirujuk','y'=>$jum_dirujuk);
			$temp[] = array('name'=>'k48j','y'=>$jum_k48j);
			$temp[] = array('name'=>'l48j','y'=>$jum_l48j);
			$arrKategori = ['SEMBUH', 'APS', 'DIRUJUK', 'MATI < 48 Jam', 'MATI > 48 Jam'];
			$arrReturn['sourcePasienKRS'] = $temp;
			$arrReturn['kategori'] = $arrKategori;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);
		}

		public static function KRSperbulan()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strMonth = $objPost->month;
			$strKategori = $objPost->kategori;

			$arrReturn = array();
			$arrReturn['titleBarThisMonth'] = 'Kunjungan '.date('F, Y',mktime(0,0,0,$strMonth,1,$strYear));
			$arrReturn['titleBarThisYear'] = 'Kunjungan '.date('Y',mktime(0,0,0,$strMonth,1,$strYear));
			$dtAwalBulan = new QDateTime($strYear . '-' . $strMonth . '-' . '1');
			$dtAwalBulan->AddMonths(1);
			$dtAwalBulan->AddDays(-1);

			$tglTerakhir = $dtAwalBulan->PhpDate('d');

			$data = array();
			$strTitle = 'Pasien KRS';
			$bulan =[
				'',
				'Januari',
				'Februari',
				'Maret',
				'April',
				'Mei',
				'Juni',
				'Juli',
				'Agustus',
				'September',
				'Oktober',
				'November',
				'Desember'
			];
			$arrReturn['sourceTitleGraphMonthly'] = $strTitle. ' Bulan ' . $bulan[$strMonth] . ' Tahun ' . $strYear;
			for ($c=1;$c<=$tglTerakhir;$c++){
				//$temp[] = array('name'=>'Data '.$c,'y'=>0);
				$data[$c] = 0;
			}
			$objDb = QApplication::$Database[1];
			// $strSql = "
			//    SELECT date_part('day', nursing_start_date) AS by_day, COUNT(hmis_patient_nursing.id) AS jumlah
			//    FROM hmis_patient_nursing
			//    WHERE 
			//    date_part('month', nursing_start_date) = '$strMonth' AND  date_part('year', nursing_start_date) = '$strYear'
			//    AND on_partition BETWEEN '$strYear-$strMonth-01' AND '$strYear-$strMonth-$tglTerakhir'
			//    AND nursing_category = '3'
			// 	AND register_json LIKE '%StatusIndex%'
			// 	AND document_back_back_date IS NOT NULL
			// 	AND checklist_status_kelengkapan = 'LENGKAP'
			//    AND state = 'A'
			//    GROUP BY by_day
			// ";
			$strSql = "
			   SELECT date_part('day', nursing_start_date) AS by_day, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE 
			   date_part('month', nursing_start_date) = '$strMonth' AND  date_part('year', nursing_start_date) = '$strYear'
			   AND on_partition BETWEEN '$strYear-$strMonth-01' AND '$strYear-$strMonth-$tglTerakhir'
			   AND nursing_category = '3'
				AND register_json LIKE '%StatusIndex%'
				AND document_back_back_date IS NOT NULL
			   AND state = 'A'
			   GROUP BY by_day
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row['by_day']]=(int)$row['jumlah'];
					//$temp[] = array('name' => 'Data ' . $row[by_month], 'y' => $row[jumlah]);
				}
			}
			$temp = array();
			for ($c=1;$c<=$tglTerakhir;$c++){
				$temp[] = array('name'=>'Tgl '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataGraphMonthly'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}

		public static function KRSpertahun()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strKategori = $objPost->kategori;

			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Pasien KRS Tahun '.$strYear;
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '3'
			   	AND register_json LIKE '%StatusIndex%'
				AND document_back_back_date IS NOT NULL
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataKRSpertahun'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}
		public static function PoliDalamTahun()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strKategori = $objPost->kategori;
			$poli = $objPost->poli;

			$temp = array();
			// $arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			
			$strTitle = $poli . ' Kunjungan Tahun ' . $strYear;
			$arrReturn['sourceTitle'] = $strTitle;			
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND department_name = '$poli'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRajal'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}
		public static function DataPenyakitPoli()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strMonth = $objPost->month;
			$strKategori = $objPost->kategori;
			$poli = $objPost->poli;

			$arrReturn = array();
			$dtAwalBulan = new QDateTime($strYear . '-' . $strMonth . '-' . '1');
			$dtAwalBulan->AddMonths(1);
			$dtAwalBulan->AddDays(-1);

			$tglTerakhir = $dtAwalBulan->PhpDate('d');

			$temp = array();
			// $arrReturn['sourceTitleProp'] = 'Proporsi Kunjungan Berdasarkan Cara Bayar';
			
			$strTitle ='Persentase Diagnosa '. $poli . ' Bulan '.$strMonth.' Tahun ' . $strYear;
			$arrReturn['sourceTitle'] = $strTitle;			
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			SELECT admission_diagnose_code_1 AS by_code, COUNT(hmis_patient_nursing.id) AS jumlah
			FROM hmis_patient_nursing
			WHERE 
			date_part('month', nursing_start_date) = '$strMonth' AND  date_part('year', nursing_start_date) = '$strYear'
			AND on_partition BETWEEN '$strYear-$strMonth-01' AND '$strYear-$strMonth-$tglTerakhir'
				AND department_name = '". $poli . "'
				AND register_json LIKE '%StatusIndex%'
				AND document_back_back_date IS NOT NULL
				AND checklist_status_kelengkapan = 'LENGKAP'
			AND state = 'A'
			GROUP BY by_code
			";
			$temp = array();
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					// $data[$row[by_code]]=(int)$row[jumlah];
					$temp[] = array(
						'name'=>$row[by_code] .'<br>'.$row[jumlah] ,
						'y'=>(int)$row[jumlah]
					);
				}
			}
			// for ($c=1;$c<=12;$c++){
			// 	$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			// }
			$arrReturn['sourceDataProp'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}

		public static function CovidDalamTahun()
		{

			$objPost = System::genObject('post');
			$strYear = $objPost->year;
			$strKategori = $objPost->kategori;

			$temp = array();
			$arrReturn['sourceTitleProp'] = 'Jumlah Pasien Positif Covid';
			
			if($strKategori == 1){
				$strTitle = 'Rawat Jalan';
			}elseif($strKategori == 2){
				$strTitle = 'IGD';
			}elseif($strKategori == 3){
				$strTitle = 'Perawatan Inap';
			}else{
				$strKategori = 0;
			}
			
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '1'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND profile_json LIKE '%POSITIF COVID%'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRajal'] = $temp;

			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '2'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND profile_json LIKE '%POSITIF COVID%'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataIGD'] = $temp;

			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT date_part('month', nursing_start_date) AS by_month, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE date_part('year', nursing_start_date) = '$strYear'
			   AND nursing_category = '3'
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND profile_json LIKE '%POSITIF COVID%'
			   AND state = 'A'
			   GROUP BY by_month
			";
			$objDbResult = $objDb->Query($strSql);
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					$data[$row[by_month]]=(int)$row[jumlah];
				}
			}
			$temp = array();
			for ($c=1;$c<=12;$c++){
				$temp[] = array('name'=>'Data '.$c,'y'=>$data[$c]);
			}
			$arrReturn['sourceDataRanap'] = $temp;

			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);

		}

		public static function PasienMasukHarian(){
			//2021-08-15
			$objPost = System::genObject('post');

			$temp = array();
			$arrReturn['judul'] = 'Pasien Masuk Harian';
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT nursing_category, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE 
			   (
				   nursing_start_date = '".date('Y-m-d', strtotime($objPost->tanggal))."'
				   OR
				   convert_to_json(hmis_patient_nursing.profile_json)->>'StartCheckinDateTime' = '".date('Y-m-d', strtotime($objPost->tanggal))."'
				)
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY nursing_category
			";
			$objDbResult = $objDb->Query($strSql);
			$temp = array();
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					switch($row["nursing_category"]){
						case '1':
							$kategori = 'Rawat Jalan';
							$color = '#0000FF';
							break;
						case '2':
							$kategori = 'IGD';
							$color = '#DDDD00';
							break;
						case '3':
							$kategori = 'Rawat Inap';
							$color = '#FF6600';
							break;
						default:
							$kategori = '0';
					}
					$temp[] = array(
						'name' => $kategori,
						'y' => intval($row["jumlah"]),
						'color' => $color,
					);
				}
			}

			$arrReturn['data'] = $temp;
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);
		}

		public static function PasienMasukByRange(){
			//2021-08-16
			$objPost = System::genObject('post');
			if($objPost->range){
				list($minDate,$maxDate) = @explode(' - ',$objPost->range);
				list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
				list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);
	
				$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
				$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');
				$startDay = $objMinDate->PhpDate('Y-m-d');
				$endDay = $objMaxDate->PhpDate('Y-m-d');
			}else{
				list($tanggal,$bulan,$tahun) = @explode('.',$objPost->mingguan);
				list($startDay, $endDay) = self::dataMingguan($tanggal, $bulan, $tahun);
				$arrReturn['rangeMinggu'] = date('d.m.Y', strtotime($startDay)) .' - '.date('d.m.Y', strtotime($endDay));
			}
			
			// $now = QDateTime::Now();
			$temp = array();
			$arrReturn['judul'] = 'Pasien Masuk';
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT nursing_category, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE 
				(
				   nursing_start_date >= '".$startDay."'
				   OR
				   convert_to_json(hmis_patient_nursing.profile_json)->>'StartCheckinDateTime' >= '".$startDay."'
				)
			   AND (
				   	nursing_start_date <= '".$endDay."'
					OR
					convert_to_json(hmis_patient_nursing.profile_json)->>'StartCheckinDateTime' <= '".$endDay."'
					)
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND state = 'A'
			   GROUP BY nursing_category
			";
			$objDbResult = $objDb->Query($strSql);
			$temp = array();
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					switch($row["nursing_category"]){
						case '1':
							$kategori = 'Rawat Jalan';
							$color = '#0000FF';
							break;
						case '2':
							$kategori = 'IGD';
							$color = '#DDDD00';
							break;
						case '3':
							$kategori = 'Rawat Inap';
							$color = '#FF6600';
							break;
						default:
							$kategori = '0';
					}
					$temp[] = array(
						'name' => $kategori,
						'y' => intval($row["jumlah"]),
						'color' => $color,
					);
				}
			}

			$arrReturn['data'] = $temp;
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			return json_encode($arrReturn);
		}
		public static function PasienCovidByRange(){
			//2021-08-16
			$objPost = System::genObject('post');
			if($objPost->range){
				list($minDate,$maxDate) = @explode(' - ',$objPost->range);
				list($minDay,$minMonth,$minYear) = @explode('.',$minDate);
				list($maxDay,$maxMonth,$maxYear) = @explode('.',$maxDate);
	
				$objMinDate = new QDateTime($minYear.'-'.$minMonth.'-'.$minDay.'00:00:00');
				$objMaxDate = new QDateTime($maxYear.'-'.$maxMonth.'-'.$maxDay.'23:59:59');
				$startDay = $objMinDate->PhpDate('Y-m-d');
				$endDay = $objMaxDate->PhpDate('Y-m-d');
			}else{
				list($tanggal,$bulan,$tahun) = @explode('.',$objPost->mingguan);
				list($startDay, $endDay) = self::dataMingguan($tanggal, $bulan, $tahun);
				$arrReturn['rangeMinggu'] = date('d.m.Y', strtotime($startDay)) .' - '.date('d.m.Y', strtotime($endDay));
			}

			// $now = QDateTime::Now();
			$temp = array();
			$arrReturn['judul'] = 'Pasien Covid';
			$objDb = QApplication::$Database[1];
			$strSql = "
			   SELECT nursing_category, COUNT(hmis_patient_nursing.id) AS jumlah
			   FROM hmis_patient_nursing
			   WHERE 
			   (	
					convert_to_json(hmis_patient_nursing.profile_json)->>'StartCheckinDateTime' >= '".$startDay."'
					OR
					nursing_start_date >= '".$startDay."'
				)
			   AND (nursing_end_date <= '".$endDay."' OR nursing_end_date IS NULL)
			   AND department_name != 'APOTIK RAWAT INAP'
			   AND department_name != 'DEPO OK'
			   AND department_name != 'APOTIK RAWAT DARURAT'
			   AND department_name != 'INSTALASI HEMODIALISA'
			   AND department_name != 'LABORATORIUM'
			   AND department_name != 'RADIOLOGI'
			   AND convert_to_json(hmis_patient_nursing.profile_json)->>'StatusCovid' = '$objPost->kasusCovid'
			   AND state = 'A'
			   GROUP BY nursing_category
			";
			$objDbResult = $objDb->Query($strSql);
			$temp = array();
			if ($objDbResult->CountRows() > 0) {
				while ($row = $objDbResult->FetchArray()) {
					switch($row["nursing_category"]){
						case '1':
							$kategori = 'Rawat Jalan';
							$color = '#0000FF';
							break;
						case '2':
							$kategori = 'IGD';
							$color = '#DDDD00';
							break;
						case '3':
							$kategori = 'Rawat Inap';
							$color = '#FF6600';
							break;
						default:
							$kategori = '0';
					}
					$temp[] = array(
						'name' => $kategori,
						'y' => intval($row["jumlah"]),
						'color' => $color,
					);
				}
			}

			$arrReturn['data'] = $temp;
			$arrReturn['status'] = 'success';
			$arrReturn['type'] = 'success';
			$arrReturn['message'] = 'success';
			// $arrReturn['debug'] = $strSql;
			return json_encode($arrReturn);
		}

		private static function dataMingguan($tanggal, $bulan, $tahun){
			$start = null;
			$end = null;
			$tgl = $tahun.'-'.$bulan.'-'.$tanggal;
			$start = date('Y-m-d', strtotime("this week", strtotime($tgl)));
			$end = date('Y-m-d', strtotime("this week +6 days", strtotime($tgl)));
			// 1 8 15 22 29
			return [$start, $end];
		}
	}
?>
